/****************************************
 * ArtemisHscAPI.cpp
 *
 * This file is autogenerated.
 *
 ****************************************/

#include "stdafx.h"

#include <string>

//////////////////////////////////////////////////////////////////////////
//
// Interface functions for Artemis CCD Camera Library
//

#include "ArtemisHscAPI.h"

#if _WIN32
	#include <windows.h>
	#include <comdef.h>
#else
	#include <dlfcn.h>
	typedef void * FARPROC;
	typedef void * HINSTANCE;
	typedef void * HWND;
	typedef void * VARIANT;
	#define __stdcall
#endif

#define artfn /* */

#define NFUNCS 100
static FARPROC pFuncs[NFUNCS];
static HINSTANCE hArtemisDLL=NULL;

// ----------------- DLL ------------------------

#ifndef _WIN32
static void * GetProcAddress(HINSTANCE hArtemisDLL, const char * method)
{
	return dlsym(hArtemisDLL, method);
}
#endif

// Return API version. XYY X=major, YY=minor
typedef int(__stdcall * TYPE_ARTEMISAPIVERSION)();
int artfn ArtemisAPIVersion()
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[2])
			pFuncs[2] = GetProcAddress(hArtemisDLL, "ArtemisAPIVersion");
		TYPE_ARTEMISAPIVERSION pArtemisAPIVersion = (TYPE_ARTEMISAPIVERSION)pFuncs[2];
		if (NULL != pArtemisAPIVersion)
			return pArtemisAPIVersion();
	}
	return (int)NULL;
}

// Return DLL version. XYY X=major, YY=minor
typedef int(__stdcall * TYPE_ARTEMISDLLVERSION)();
int artfn ArtemisDLLVersion()
{
	static TYPE_ARTEMISDLLVERSION method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISDLLVERSION)GetProcAddress(hArtemisDLL, "ArtemisDLLVersion");

	if (method == NULL)
		return -1;

	return method();
}


// ----------------- Connect / Disconnect ------------------------

// Connect to given device. If Device=-1, connect to first available
// Returns handle if connected as requested, else NULL
typedef ArtemisHandle(__stdcall * TYPE_ARTEMISCONNECT)(int Device);
ArtemisHandle artfn ArtemisConnect(int Device)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[11])
			pFuncs[11] = GetProcAddress(hArtemisDLL, "ArtemisConnect");
		TYPE_ARTEMISCONNECT pArtemisConnect = (TYPE_ARTEMISCONNECT)pFuncs[11];
		if (NULL != pArtemisConnect)
			return pArtemisConnect(Device);
	}
	return (ArtemisHandle)NULL;
}

// Returns TRUE if currently connected to a device
typedef bool(__stdcall * TYPE_ARTEMISISCONNECTED)(ArtemisHandle hCam);
bool artfn ArtemisIsConnected(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[41])
			pFuncs[41] = GetProcAddress(hArtemisDLL, "ArtemisIsConnected");
		TYPE_ARTEMISISCONNECTED pArtemisIsConnected = (TYPE_ARTEMISISCONNECTED)pFuncs[41];
		if (NULL != pArtemisIsConnected)
			return (bool)(pArtemisIsConnected(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Disconnect from given device.
// Returns true if disconnected as requested
typedef bool(__stdcall * TYPE_ARTEMISDISCONNECT)(ArtemisHandle hCam);
bool artfn ArtemisDisconnect(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[21])
			pFuncs[21] = GetProcAddress(hArtemisDLL, "ArtemisDisconnect");
		TYPE_ARTEMISDISCONNECT pArtemisDisconnect = (TYPE_ARTEMISDISCONNECT)pFuncs[21];
		if (NULL != pArtemisDisconnect)
			return (bool)(pArtemisDisconnect(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Disconnect all connected devices
typedef bool(__stdcall * TYPE_ARTEMISDISCONNECTALL)();
bool artfn ArtemisDisconnectAll()
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[22])
			pFuncs[22] = GetProcAddress(hArtemisDLL, "ArtemisDisconnectAll");
		TYPE_ARTEMISDISCONNECTALL pArtemisDisconnectAll = (TYPE_ARTEMISDISCONNECTALL)pFuncs[22];
		if (NULL != pArtemisDisconnectAll)
			return (bool)(pArtemisDisconnectAll() ? 1 : 0);
	}
	return (bool)NULL;
}

// Disconnect all connected devices
typedef int(__stdcall * TYPE_ARTEMISSETALWAYSCONNECT)(bool alwaysConnect);
int artfn ArtemisSetAlwaysConnect(bool alwaysConnect)
{
	static TYPE_ARTEMISSETALWAYSCONNECT method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISSETALWAYSCONNECT)GetProcAddress(hArtemisDLL, "ArtemisSetAlwaysConnect");

	if (method == NULL)
		return (int)NULL;

	return method(alwaysConnect);
}


// ------------------- Camera Info -----------------------------------

// Return camera type and serial number
// Low byte of flags is camera type, 1=4021, 2=11002, 3=IC24/285, 4=205, 5=QC
// Bits 8-31 of flags are reserved.
typedef int(__stdcall * TYPE_ARTEMISCAMERASERIAL)(ArtemisHandle hCam, int* flags, int* serial);
int artfn ArtemisCameraSerial(ArtemisHandle hCam, int* flags, int* serial)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[5])
			pFuncs[5] = GetProcAddress(hArtemisDLL, "ArtemisCameraSerial");
		TYPE_ARTEMISCAMERASERIAL pArtemisCameraSerial = (TYPE_ARTEMISCAMERASERIAL)pFuncs[5];
		if (NULL != pArtemisCameraSerial)
			return pArtemisCameraSerial(hCam, flags, serial);
	}
	return (int)NULL;
}

// Return colour properties
typedef int(__stdcall * TYPE_ARTEMISCOLOURPROPERTIES)(ArtemisHandle hCam, ARTEMISCOLOURTYPE * colourType, int * normalOffsetX, int * normalOffsetY, int * previewOffsetX, int * previewOffsetY);
int artfn ArtemisColourProperties(ArtemisHandle hCam, ARTEMISCOLOURTYPE * colourType, int * normalOffsetX, int * normalOffsetY, int * previewOffsetX, int * previewOffsetY)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[8])
			pFuncs[8] = GetProcAddress(hArtemisDLL, "ArtemisColourProperties");
		TYPE_ARTEMISCOLOURPROPERTIES pArtemisColourProperties = (TYPE_ARTEMISCOLOURPROPERTIES)pFuncs[8];
		if (NULL != pArtemisColourProperties)
			return pArtemisColourProperties(hCam, colourType, normalOffsetX, normalOffsetY, previewOffsetX, previewOffsetY);
	}
	return (int)NULL;
}

// Fills in pProp with camera properties
typedef int(__stdcall * TYPE_ARTEMISPROPERTIES)(ArtemisHandle hCam, struct ARTEMISPROPERTIES * pProp);
int artfn ArtemisProperties(ArtemisHandle hCam, struct ARTEMISPROPERTIES * pProp)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[49])
			pFuncs[49] = GetProcAddress(hArtemisDLL, "ArtemisProperties");
		TYPE_ARTEMISPROPERTIES pArtemisProperties = (TYPE_ARTEMISPROPERTIES)pFuncs[49];
		if (NULL != pArtemisProperties)
			return pArtemisProperties(hCam, pProp);
	}
	return (int)NULL;
}

// Get USB Identifier of Nth USB device. Return false if no such device.
// pName must be at least 40 chars long.
typedef bool(__stdcall * TYPE_ARTEMISDEVICENAME)(int Device, char * pName);
bool artfn ArtemisDeviceName(int Device, char * pName)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[19])
			pFuncs[19] = GetProcAddress(hArtemisDLL, "ArtemisDeviceName");
		TYPE_ARTEMISDEVICENAME pArtemisDeviceName = (TYPE_ARTEMISDEVICENAME)pFuncs[19];
		if (NULL != pArtemisDeviceName)
			return (bool)(pArtemisDeviceName(Device, pName) ? 1 : 0);
	}
	return (bool)NULL;
}

// Get USB Serial number of Nth USB device. Return false if no such device.
// pName must be at least 40 chars long.
typedef bool(__stdcall * TYPE_ARTEMISDEVICESERIAL)(int Device, char * pName);
bool artfn ArtemisDeviceSerial(int Device, char * pName)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[20])
			pFuncs[20] = GetProcAddress(hArtemisDLL, "ArtemisDeviceSerial");
		TYPE_ARTEMISDEVICESERIAL pArtemisDeviceSerial = (TYPE_ARTEMISDEVICESERIAL)pFuncs[20];
		if (NULL != pArtemisDeviceSerial)
			return (bool)(pArtemisDeviceSerial(Device, pName) ? 1 : 0);
	}
	return (bool)NULL;
}

// Return true if Nth USB device exists and is a camera.
typedef bool(__stdcall * TYPE_ARTEMISDEVICEISCAMERA)(int Device);
bool artfn ArtemisDeviceIsCamera(int Device)
{
	try
	{	
		if (hArtemisDLL)
		{
			if (NULL == pFuncs[14])
				pFuncs[14] = GetProcAddress(hArtemisDLL, "ArtemisDeviceIsCamera");
			TYPE_ARTEMISDEVICEISCAMERA pArtemisDeviceIsCamera = (TYPE_ARTEMISDEVICEISCAMERA)pFuncs[14];
			if (NULL != pArtemisDeviceIsCamera)
				return (bool)(pArtemisDeviceIsCamera(Device) ? 1 : 0);
		}
		bool result = (bool)NULL;
		return result;
	}
	catch (...)
	{
		return (bool)NULL;
	}
}

typedef bool(__stdcall * TYPE_ARTEMISDEVICEPRESENT)(int Device);
bool artfn ArtemisDeviceIsPresent(int Device)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[18])
			pFuncs[18] = GetProcAddress(hArtemisDLL, "ArtemisDevicePresent");
		TYPE_ARTEMISDEVICEPRESENT pArtemisDevicePresent = (TYPE_ARTEMISDEVICEPRESENT)pFuncs[18];
		if (NULL != pArtemisDevicePresent)
			return (bool)(pArtemisDevicePresent(Device) ? 1 : 0);
	}
	return (bool)NULL;
}


// ------------------- Exposures -----------------------------------

// Start an exposure
typedef int(__stdcall * TYPE_ARTEMISSTARTEXPOSURE)(ArtemisHandle hCam, float Seconds);
int artfn ArtemisStartExposure(ArtemisHandle hCam, float Seconds)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[56])
			pFuncs[56] = GetProcAddress(hArtemisDLL, "ArtemisStartExposure");
		TYPE_ARTEMISSTARTEXPOSURE pArtemisStartExposure = (TYPE_ARTEMISSTARTEXPOSURE)pFuncs[56];
		if (NULL != pArtemisStartExposure)
			return pArtemisStartExposure(hCam, Seconds);
	}
	return (int)NULL;
}

// Start an exposure
typedef int(__stdcall * TYPE_ARTEMISSTARTEXPOSUREMS)(ArtemisHandle hCam, int ms);
int artfn ArtemisStartExposureMS(ArtemisHandle hCam, int ms)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[57])
			pFuncs[57] = GetProcAddress(hArtemisDLL, "ArtemisStartExposureMS");
		TYPE_ARTEMISSTARTEXPOSUREMS pArtemisStartExposureMS = (TYPE_ARTEMISSTARTEXPOSUREMS)pFuncs[57];
		if (NULL != pArtemisStartExposureMS)
			return pArtemisStartExposureMS(hCam, ms);
	}
	return (int)NULL;
}

// Prematurely end an exposure, collecting image data.
typedef int(__stdcall * TYPE_ARTEMISSTOPEXPOSURE)(ArtemisHandle hCam);
int artfn ArtemisStopExposure(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[58])
			pFuncs[58] = GetProcAddress(hArtemisDLL, "ArtemisStopExposure");
		TYPE_ARTEMISSTOPEXPOSURE pArtemisStopExposure = (TYPE_ARTEMISSTOPEXPOSURE)pFuncs[58];
		if (NULL != pArtemisStopExposure)
			return pArtemisStopExposure(hCam);
	}
	return (int)NULL;
}

// Abort exposure, if one is in progress
typedef int(__stdcall * TYPE_ARTEMISABORTEXPOSURE)(ArtemisHandle hCam);
int artfn ArtemisAbortExposure(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[0])
			pFuncs[0] = GetProcAddress(hArtemisDLL, "ArtemisAbortExposure");
		TYPE_ARTEMISABORTEXPOSURE pArtemisAbortExposure = (TYPE_ARTEMISABORTEXPOSURE)pFuncs[0];
		if (NULL != pArtemisAbortExposure)
			return pArtemisAbortExposure(hCam);
	}
	return (int)NULL;
}

// Return true if an image is ready to be retrieved
typedef bool(__stdcall * TYPE_ARTEMISIMAGEREADY)(ArtemisHandle hCam);
bool artfn ArtemisImageReady(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[39])
			pFuncs[39] = GetProcAddress(hArtemisDLL, "ArtemisImageReady");
		TYPE_ARTEMISIMAGEREADY pArtemisImageReady = (TYPE_ARTEMISIMAGEREADY)pFuncs[39];
		if (NULL != pArtemisImageReady)
			return (bool)(pArtemisImageReady(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Return true if an image is ready to be retrieved
typedef bool(__stdcall * TYPE_ARTEMISIMAGEREADYNET)(ArtemisHandle hCam);
bool artfn ArtemisImageReadyNET(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[40])
			pFuncs[40] = GetProcAddress(hArtemisDLL, "ArtemisImageReadyNET");
		TYPE_ARTEMISIMAGEREADYNET pArtemisImageReadyNET = (TYPE_ARTEMISIMAGEREADYNET)pFuncs[40];
		if (NULL != pArtemisImageReadyNET)
			return (bool)(pArtemisImageReadyNET(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Retrieve the current camera state
typedef int(__stdcall * TYPE_ARTEMISCAMERASTATE)(ArtemisHandle hCam);
int artfn ArtemisCameraState(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[6])
			pFuncs[6] = GetProcAddress(hArtemisDLL, "ArtemisCameraState");
		TYPE_ARTEMISCAMERASTATE pArtemisCameraState = (TYPE_ARTEMISCAMERASTATE)pFuncs[6];
		if (NULL != pArtemisCameraState)
			return pArtemisCameraState(hCam);
	}
	return (int)NULL;
}

// Return time remaining in current exposure, in seconds
typedef float(__stdcall * TYPE_ARTEMISEXPOSURETIMEREMAINING)(ArtemisHandle hCam);
float artfn ArtemisExposureTimeRemaining(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[25])
			pFuncs[25] = GetProcAddress(hArtemisDLL, "ArtemisExposureTimeRemaining");
		TYPE_ARTEMISEXPOSURETIMEREMAINING pArtemisExposureTimeRemaining = (TYPE_ARTEMISEXPOSURETIMEREMAINING)pFuncs[25];
		if (NULL != pArtemisExposureTimeRemaining)
			return pArtemisExposureTimeRemaining(hCam);
	}
	return (float)NULL;
}

// Percentage downloaded
typedef int(__stdcall * TYPE_ARTEMISDOWNLOADPERCENT)(ArtemisHandle hCam);
int artfn ArtemisDownloadPercent(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[23])
			pFuncs[23] = GetProcAddress(hArtemisDLL, "ArtemisDownloadPercent");
		TYPE_ARTEMISDOWNLOADPERCENT pArtemisDownloadPercent = (TYPE_ARTEMISDOWNLOADPERCENT)pFuncs[23];
		if (NULL != pArtemisDownloadPercent)
			return pArtemisDownloadPercent(hCam);
	}
	return (int)NULL;
}

// Retrieve image dimensions and binning factors.
// x,y are actual CCD locations. w,h are pixel dimensions of image
typedef int(__stdcall * TYPE_ARTEMISGETIMAGEDATA)(ArtemisHandle hCam, int * x, int * y, int * w, int * h, int * binx, int * biny);
int artfn ArtemisGetImageData(ArtemisHandle hCam, int * x, int * y, int * w, int * h, int * binx, int * biny)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[31])
			pFuncs[31] = GetProcAddress(hArtemisDLL, "ArtemisGetImageData");
		TYPE_ARTEMISGETIMAGEDATA pArtemisGetImageData = (TYPE_ARTEMISGETIMAGEDATA)pFuncs[31];
		if (NULL != pArtemisGetImageData)
			return pArtemisGetImageData(hCam, x, y, w, h, binx, biny);
	}
	return (int)NULL;
}

typedef int(__stdcall * TYPE_ARTEMISGETIMAGEBUFFERFILE)(ArtemisHandle hCam, int * fileSize, char * fileName);
int artfn ArtemisGetImageBufferFile(ArtemisHandle hCam, int * fileSize, char * fileName)
{
	static TYPE_ARTEMISGETIMAGEBUFFERFILE method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISGETIMAGEBUFFERFILE)GetProcAddress(hArtemisDLL, "ArtemisGetImageBufferFile");

	if (method == NULL)
		return (int)NULL;

	return method(hCam, fileSize, fileName);
}

// Return pointer to internal image buffer (actually unsigned shorts)
typedef void* (__stdcall * TYPE_ARTEMISIMAGEBUFFER)(ArtemisHandle hCam);
void* artfn ArtemisImageBuffer(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[38])
			pFuncs[38] = GetProcAddress(hArtemisDLL, "ArtemisImageBuffer");
		TYPE_ARTEMISIMAGEBUFFER pArtemisImageBuffer = (TYPE_ARTEMISIMAGEBUFFER)pFuncs[38];
		if (NULL != pArtemisImageBuffer)
			return pArtemisImageBuffer(hCam);
	}
	return (void*)NULL;
}

// Retrieve the downloaded image as a 2D array of type VARIANT
typedef int(__stdcall * TYPE_ARTEMISGETIMAGEARRAY)(ArtemisHandle hCam, VARIANT * pImageArray);
int artfn ArtemisGetImageArray(ArtemisHandle hCam, VARIANT * pImageArray)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[30])
			pFuncs[30] = GetProcAddress(hArtemisDLL, "ArtemisGetImageArray");
		TYPE_ARTEMISGETIMAGEARRAY pArtemisGetImageArray = (TYPE_ARTEMISGETIMAGEARRAY)pFuncs[30];
		if (NULL != pArtemisGetImageArray)
			return pArtemisGetImageArray(hCam, pImageArray);
	}
	return (int)NULL;
}

// Return duration of last exposure, in seconds
typedef float(__stdcall * TYPE_ARTEMISLASTEXPOSUREDURATION)(ArtemisHandle hCam);
float artfn ArtemisLastExposureDuration(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[42])
			pFuncs[42] = GetProcAddress(hArtemisDLL, "ArtemisLastExposureDuration");
		TYPE_ARTEMISLASTEXPOSUREDURATION pArtemisLastExposureDuration = (TYPE_ARTEMISLASTEXPOSUREDURATION)pFuncs[42];
		if (NULL != pArtemisLastExposureDuration)
			return pArtemisLastExposureDuration(hCam);
	}
	return (float)NULL;
}

// Return ptr to static buffer containing time of start of last exposure
typedef char* (__stdcall * TYPE_ARTEMISLASTSTARTTIME)(ArtemisHandle hCam);
char* artfn ArtemisLastStartTime(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[43])
			pFuncs[43] = GetProcAddress(hArtemisDLL, "ArtemisLastStartTime");
		TYPE_ARTEMISLASTSTARTTIME pArtemisLastStartTime = (TYPE_ARTEMISLASTSTARTTIME)pFuncs[43];
		if (NULL != pArtemisLastStartTime)
			return pArtemisLastStartTime(hCam);
	}
	return (char*)NULL;
}

// Return fraction-of-a-second part of time of start of last exposure
// NB timing accuracy only justifies ~0.1s precision but milliseconds returned in case it might be useful
typedef int(__stdcall * TYPE_ARTEMISLASTSTARTTIMEMILLISECONDS)(ArtemisHandle hCam);
int artfn ArtemisLastStartTimeMilliseconds(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[44])
			pFuncs[44] = GetProcAddress(hArtemisDLL, "ArtemisLastStartTimeMilliseconds");
		TYPE_ARTEMISLASTSTARTTIMEMILLISECONDS pArtemisLastStartTimeMilliseconds = (TYPE_ARTEMISLASTSTARTTIMEMILLISECONDS)pFuncs[44];
		if (NULL != pArtemisLastStartTimeMilliseconds)
			return pArtemisLastStartTimeMilliseconds(hCam);
	}
	return (int)NULL;
}

// Set a window message to be posted on completion of image download
// hWnd=NULL for no message.
typedef int(__stdcall * TYPE_ARTEMISEXPOSUREREADYCALLBACK)(ArtemisHandle hCam, HWND hWnd, int msg, int wParam, int lParam);
int artfn ArtemisExposureReadyCallback(ArtemisHandle hCam, HWND hWnd, int msg, int wParam, int lParam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[24])
			pFuncs[24] = GetProcAddress(hArtemisDLL, "ArtemisExposureReadyCallback");
		TYPE_ARTEMISEXPOSUREREADYCALLBACK pArtemisExposureReadyCallback = (TYPE_ARTEMISEXPOSUREREADYCALLBACK)pFuncs[24];
		if (NULL != pArtemisExposureReadyCallback)
			return pArtemisExposureReadyCallback(hCam, hWnd, msg, wParam, lParam);
	}
	return (int)NULL;
}


// ------------------- Temperature -----------------------------------

typedef int(__stdcall * TYPE_ARTEMISTEMPERATURESENSORINFO)(ArtemisHandle hCam, int sensor, int* temperature);
int artfn ArtemisTemperatureSensorInfo(ArtemisHandle hCam, int sensor, int* temperature)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[64])
			pFuncs[64] = GetProcAddress(hArtemisDLL, "ArtemisTemperatureSensorInfo");
		TYPE_ARTEMISTEMPERATURESENSORINFO pArtemisTemperatureSensorInfo = (TYPE_ARTEMISTEMPERATURESENSORINFO)pFuncs[64];
		if (NULL != pArtemisTemperatureSensorInfo)
			return pArtemisTemperatureSensorInfo(hCam, sensor, temperature);
	}
	return (int)NULL;
}

typedef int(__stdcall * TYPE_ARTEMISSETCOOLING)(ArtemisHandle hCam, int setpoint);
int artfn ArtemisSetCooling(ArtemisHandle hCam, int setpoint)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[52])
			pFuncs[52] = GetProcAddress(hArtemisDLL, "ArtemisSetCooling");
		TYPE_ARTEMISSETCOOLING pArtemisSetCooling = (TYPE_ARTEMISSETCOOLING)pFuncs[52];
		if (NULL != pArtemisSetCooling)
			return pArtemisSetCooling(hCam, setpoint);
	}
	return (int)NULL;
}

typedef int(__stdcall * TYPE_ARTEMISCOOLINGINFO)(ArtemisHandle hCam, int* flags, int* level, int* minlvl, int* maxlvl, int* setpoint);
int artfn ArtemisCoolingInfo(ArtemisHandle hCam, int* flags, int* level, int* minlvl, int* maxlvl, int* setpoint)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[13])
			pFuncs[13] = GetProcAddress(hArtemisDLL, "ArtemisCoolingInfo");
		TYPE_ARTEMISCOOLINGINFO pArtemisCoolingInfo = (TYPE_ARTEMISCOOLINGINFO)pFuncs[13];
		if (NULL != pArtemisCoolingInfo)
			return pArtemisCoolingInfo(hCam, flags, level, minlvl, maxlvl, setpoint);
	}
	return (int)NULL;
}

typedef int(__stdcall * TYPE_ARTEMISCOOLERWARMUP)(ArtemisHandle hCam);
int artfn ArtemisCoolerWarmUp(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[12])
			pFuncs[12] = GetProcAddress(hArtemisDLL, "ArtemisCoolerWarmUp");
		TYPE_ARTEMISCOOLERWARMUP pArtemisCoolerWarmUp = (TYPE_ARTEMISCOOLERWARMUP)pFuncs[12];
		if (NULL != pArtemisCoolerWarmUp)
			return pArtemisCoolerWarmUp(hCam);
	}
	return (int)NULL;
}

// Get the window heater power
typedef int(__stdcall * TYPE_ARTEMISGETWINDOWHEATERPOWER)(ArtemisHandle hCam, int* windowHeaterPower);
int artfn ArtemisGetWindowHeaterPower(ArtemisHandle hCam, int* windowHeaterPower)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[84])
			pFuncs[84] = GetProcAddress(hArtemisDLL, "ArtemisGetWindowHeaterPower");
		TYPE_ARTEMISGETWINDOWHEATERPOWER pArtemisGetWindowHeaterPower = (TYPE_ARTEMISGETWINDOWHEATERPOWER)pFuncs[84];
		if (NULL != pArtemisGetWindowHeaterPower)
			return pArtemisGetWindowHeaterPower(hCam, windowHeaterPower);
	}
	return (int)NULL;
}

// Set the window heater power
typedef int(__stdcall * TYPE_ARTEMISSETWINDOWHEATERPOWER)(ArtemisHandle hCam, int windowHeaterPower);
int artfn ArtemisSetWindowHeaterPower(ArtemisHandle hCam, int windowHeaterPower)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[83])
			pFuncs[83] = GetProcAddress(hArtemisDLL, "ArtemisSetWindowHeaterPower");
		TYPE_ARTEMISSETWINDOWHEATERPOWER pArtemisSetWindowHeaterPower = (TYPE_ARTEMISSETWINDOWHEATERPOWER)pFuncs[83];
		if (NULL != pArtemisSetWindowHeaterPower)
			return pArtemisSetWindowHeaterPower(hCam, windowHeaterPower);
	}
	return (int)NULL;
}



// ------------------- Guiding -----------------------------------

// Activate a guide relay, axis=0,1,2,3 for N,S,E,W
typedef int(__stdcall * TYPE_ARTEMISGUIDE)(ArtemisHandle hCam, int axis);
int artfn ArtemisGuide(ArtemisHandle hCam, int axis)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[35])
			pFuncs[35] = GetProcAddress(hArtemisDLL, "ArtemisGuide");
		TYPE_ARTEMISGUIDE pArtemisGuide = (TYPE_ARTEMISGUIDE)pFuncs[35];
		if (NULL != pArtemisGuide)
			return pArtemisGuide(hCam, axis);
	}
	return (int)NULL;
}

// Set guide port bits (bit 1 = N, bit 2 = S, bit 3 = E, bit 4 = W)
typedef int(__stdcall * TYPE_ARTEMISGUIDEPORT)(ArtemisHandle hCam, int nibble);
int artfn ArtemisGuidePort(ArtemisHandle hCam, int nibble)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[36])
			pFuncs[36] = GetProcAddress(hArtemisDLL, "ArtemisGuidePort");
		TYPE_ARTEMISGUIDEPORT pArtemisGuidePort = (TYPE_ARTEMISGUIDEPORT)pFuncs[36];
		if (NULL != pArtemisGuidePort)
			return pArtemisGuidePort(hCam, nibble);
	}
	return (int)NULL;
}

// Activate a guide relay for a short interval, axis=0,1,2,3 for N,S,E,W
typedef int(__stdcall * TYPE_ARTEMISPULSEGUIDE)(ArtemisHandle hCam, int axis, int milli);
int artfn ArtemisPulseGuide(ArtemisHandle hCam, int axis, int milli)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[50])
			pFuncs[50] = GetProcAddress(hArtemisDLL, "ArtemisPulseGuide");
		TYPE_ARTEMISPULSEGUIDE pArtemisPulseGuide = (TYPE_ARTEMISPULSEGUIDE)pFuncs[50];
		if (NULL != pArtemisPulseGuide)
			return pArtemisPulseGuide(hCam, axis, milli);
	}
	return (int)NULL;
}

// Switch off all guide relays
typedef int(__stdcall * TYPE_ARTEMISSTOPGUIDING)(ArtemisHandle hCam);
int artfn ArtemisStopGuiding(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[59])
			pFuncs[59] = GetProcAddress(hArtemisDLL, "ArtemisStopGuiding");
		TYPE_ARTEMISSTOPGUIDING pArtemisStopGuiding = (TYPE_ARTEMISSTOPGUIDING)pFuncs[59];
		if (NULL != pArtemisStopGuiding)
			return pArtemisStopGuiding(hCam);
	}
	return (int)NULL;
}

// Enable/disable termination of guiding before downloading the image
typedef int(__stdcall * TYPE_ARTEMISSTOPGUIDINGBEFOREDOWNLOAD)(ArtemisHandle hCam, bool bEnable);
int artfn ArtemisStopGuidingBeforeDownload(ArtemisHandle hCam, bool bEnable)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[60])
			pFuncs[60] = GetProcAddress(hArtemisDLL, "ArtemisStopGuidingBeforeDownload");
		TYPE_ARTEMISSTOPGUIDINGBEFOREDOWNLOAD pArtemisStopGuidingBeforeDownload = (TYPE_ARTEMISSTOPGUIDINGBEFOREDOWNLOAD)pFuncs[60];
		if (NULL != pArtemisStopGuidingBeforeDownload)
			return pArtemisStopGuidingBeforeDownload(hCam, bEnable);
	}
	return (int)NULL;
}



// ------------------- Filter Wheel -----------------------------------

// Return info on internal filterwheel
typedef int(__stdcall * TYPE_ARTEMISFILTERWHEELINFO)(ArtemisHandle hCam, int * numFilters, int * moving, int * currentPos, int * targetPos);
int artfn ArtemisFilterWheelInfo(ArtemisHandle hCam, int * numFilters, int * moving, int * currentPos, int * targetPos)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[9])
			pFuncs[9] = GetProcAddress(hArtemisDLL, "ArtemisFilterWheelInfo");
		TYPE_ARTEMISFILTERWHEELINFO pArtemisFilterWheelInfo = (TYPE_ARTEMISFILTERWHEELINFO)pFuncs[9];
		if (NULL != pArtemisFilterWheelInfo)
			return pArtemisFilterWheelInfo(hCam, numFilters, moving, currentPos, targetPos);
	}
	return (int)NULL;
}

// Tell internal filterwheel to move to new position
typedef int(__stdcall * TYPE_ARTEMISFILTERWHEELMOVE)(ArtemisHandle hCam, int targetPos);
int artfn ArtemisFilterWheelMove(ArtemisHandle hCam, int targetPos)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[10])
			pFuncs[10] = GetProcAddress(hArtemisDLL, "ArtemisFilterWheelMove");
		TYPE_ARTEMISFILTERWHEELMOVE pArtemisFilterWheelMove = (TYPE_ARTEMISFILTERWHEELMOVE)pFuncs[10];
		if (NULL != pArtemisFilterWheelMove)
			return pArtemisFilterWheelMove(hCam, targetPos);
	}
	return (int)NULL;
}


// ---------------  External Filter Wheel -------------------------------
typedef bool(__stdcall * TYPE_ARTEMISEFWISPRESENT)(int iDevice);
artfn bool ArtemisEFWIsPresent(int iDevice)
{
	static TYPE_ARTEMISEFWISPRESENT method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWISPRESENT)GetProcAddress(hArtemisDLL, "ArtemisEFWIsPresent");

	if (method == NULL)
		return (int)NULL;

	return method(iDevice);
}

typedef int(__stdcall * TYPE_ARTEMISEFWGETDEVICEDETAILS)(int iDevice, ARTEMISEFWTYPE * type, char * serialNumber);
artfn int  ArtemisEFWGetDeviceDetails(int iDevice, ARTEMISEFWTYPE * type, char * serialNumber)
{
	static TYPE_ARTEMISEFWGETDEVICEDETAILS method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWGETDEVICEDETAILS)GetProcAddress(hArtemisDLL, "ArtemisEFWGetDeviceDetails");

	if (method == NULL)
		return (int)NULL;

	return method(iDevice, type, serialNumber);
}

typedef ArtemisHandle(__stdcall * TYPE_ARTEMISEFWCONNECT)(int iDevice);
ArtemisHandle artfn ArtemisEFWConnect(int iDevice)
{
	static TYPE_ARTEMISEFWCONNECT method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWCONNECT)GetProcAddress(hArtemisDLL, "ArtemisEFWConnect");

	if (method == NULL)
		return (int)NULL;

	return method(iDevice);
}

typedef int(__stdcall * TYPE_ARTEMISEFWDISCONNECT)(ArtemisHandle handle);
int artfn ArtemisEFWDisconnect(ArtemisHandle handle)
{
	static TYPE_ARTEMISEFWDISCONNECT method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWDISCONNECT)GetProcAddress(hArtemisDLL, "ArtemisEFWDisconnect");

	if (method == NULL)
		return (int)NULL;

	return method(handle);
}

typedef int(__stdcall * TYPE_ARTEMISEFWGETDETAILS)(ArtemisHandle handle, ARTEMISEFWTYPE * type, char * serialNumber);
artfn int  ArtemisEFWGetDetails(ArtemisHandle handle, ARTEMISEFWTYPE * type, char * serialNumber)
{
	static TYPE_ARTEMISEFWGETDETAILS method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWGETDETAILS)GetProcAddress(hArtemisDLL, "ArtemisEFWGetDetails");

	if (method == NULL)
		return (int)NULL;

	return method(handle, type, serialNumber);
}

typedef int(__stdcall * TYPE_ARTEMISEFWNMRPOSITION)(ArtemisHandle handle, int * nPosition);
int artfn ArtemisEFWNmrPosition(ArtemisHandle handle, int * nPosition)
{
	static TYPE_ARTEMISEFWNMRPOSITION method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWNMRPOSITION)GetProcAddress(hArtemisDLL, "ArtemisEFWNmrPosition");

	if (method == NULL)
		return (int)NULL;

	return method(handle, nPosition);
}

typedef int(__stdcall * TYPE_ARTEMISEFWSETPOSITION)(ArtemisHandle handle, int iPosition);
int artfn ArtemisEFWSetPosition(ArtemisHandle handle, int iPosition)
{
	static TYPE_ARTEMISEFWSETPOSITION method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWSETPOSITION)GetProcAddress(hArtemisDLL, "ArtemisEFWSetPosition");

	if (method == NULL)
		return (int)NULL;

	return method(handle, iPosition);
}

typedef int(__stdcall * TYPE_ARTEMISEFWGETPOSITION)(ArtemisHandle handle, int * iPosition, bool * isMoving);
int artfn ArtemisEFWGetPosition(ArtemisHandle handle, int * iPosition, bool * isMoving)
{
	static TYPE_ARTEMISEFWGETPOSITION method = NULL;

	if (method == NULL)
		method = (TYPE_ARTEMISEFWGETPOSITION)GetProcAddress(hArtemisDLL, "ArtemisEFWGetPosition");

	if (method == NULL)
		return (int)NULL;

	return method(handle, iPosition, isMoving);
}



// ------------------- GPIO -----------------------------------

// Get the number of GPIO lines and the value of the input on each line
// (value of input on nth line given by value of nth bit in lineValues)
typedef int(__stdcall * TYPE_ARTEMISGETGPIOINFORMATION)(ArtemisHandle hCam, int* lineCount, int* lineValues);
int artfn ArtemisGetGpioInformation(ArtemisHandle hCam, int* lineCount, int* lineValues)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[73])
			pFuncs[73] = GetProcAddress(hArtemisDLL, "ArtemisGetGpioInformation");
		TYPE_ARTEMISGETGPIOINFORMATION pArtemisGetGpioInformation = (TYPE_ARTEMISGETGPIOINFORMATION)pFuncs[73];
		if (NULL != pArtemisGetGpioInformation)
			return pArtemisGetGpioInformation(hCam, lineCount, lineValues);
	}
	return (int)NULL;
}

// Set the GPIO line directions
// (nth line is set as an input (output) if nth bit of directionMask is 1 (0)
typedef int(__stdcall * TYPE_ARTEMISSETGPIODIRECTION)(ArtemisHandle hCam, int directionMask);
int artfn ArtemisSetGpioDirection(ArtemisHandle hCam, int directionMask)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[76])
			pFuncs[76] = GetProcAddress(hArtemisDLL, "ArtemisSetGpioDirection");
		TYPE_ARTEMISSETGPIODIRECTION pArtemisSetGpioDirection = (TYPE_ARTEMISSETGPIODIRECTION)pFuncs[76];
		if (NULL != pArtemisSetGpioDirection)
			return pArtemisSetGpioDirection(hCam, directionMask);
	}
	return (int)NULL;
}

//Set GPIO output line values
// (nth line (if it's an output) is set to high (low) if nth bit of lineValues is 1 (0)
typedef int(__stdcall * TYPE_ARTEMISSETGPIOVALUES)(ArtemisHandle hCam, int lineValues);
int artfn ArtemisSetGpioValues(ArtemisHandle hCam, int lineValues)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[77])
			pFuncs[77] = GetProcAddress(hArtemisDLL, "ArtemisSetGpioValues");
		TYPE_ARTEMISSETGPIOVALUES pArtemisSetGpioValues = (TYPE_ARTEMISSETGPIOVALUES)pFuncs[77];
		if (NULL != pArtemisSetGpioValues)
			return pArtemisSetGpioValues(hCam, lineValues);
	}
	return (int)NULL;
}



// ------------------- Gain -----------------------------------

typedef int(__stdcall * TYPE_ARTEMISGETGAIN)(ArtemisHandle hCam, bool isPreview, int * gain, int * offset);
int artfn ArtemisGetGain(ArtemisHandle hCam, bool isPreview, int * gain, int * offset)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[65])
			pFuncs[65] = GetProcAddress(hArtemisDLL, "ArtemisGetGain");
		TYPE_ARTEMISGETGAIN pArtemisGetGain = (TYPE_ARTEMISGETGAIN)pFuncs[65];
		if (NULL != pArtemisGetGain)
			return pArtemisGetGain(hCam, isPreview, gain, offset);
	}
	return (int)NULL;
}


typedef int(__stdcall * TYPE_ARTEMISSETGAIN)(ArtemisHandle hCam, bool isPreview, int gain, int offset);
int artfn ArtemisSetGain(ArtemisHandle hCam, bool isPreview, int gain, int offset)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[66])
			pFuncs[66] = GetProcAddress(hArtemisDLL, "ArtemisSetGain");
		TYPE_ARTEMISSETGAIN pArtemisSetGain = (TYPE_ARTEMISSETGAIN)pFuncs[66];
		if (NULL != pArtemisSetGain)
			return pArtemisSetGain(hCam, isPreview, gain, offset);
	}
	return (int)NULL;
}

// ------------------- Amplifier -----------------------------------

// Set the CCD amplifier on or off
typedef int(__stdcall * TYPE_ARTEMISAMPLIFIER)(ArtemisHandle hCam, bool bOn);
int artfn ArtemisAmplifier(ArtemisHandle hCam, bool bOn)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[1])
			pFuncs[1] = GetProcAddress(hArtemisDLL, "ArtemisAmplifier");
		TYPE_ARTEMISAMPLIFIER pArtemisAmplifier = (TYPE_ARTEMISAMPLIFIER)pFuncs[1];
		if (NULL != pArtemisAmplifier)
			return pArtemisAmplifier(hCam, bOn);
	}
	return (int)NULL;
}

// Return true if amp switched off during exposures
typedef bool(__stdcall * TYPE_ARTEMISGETAMPLIFIERSWITCHED)(ArtemisHandle hCam);
bool artfn ArtemisGetAmplifierSwitched(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[26])
			pFuncs[26] = GetProcAddress(hArtemisDLL, "ArtemisGetAmplifierSwitched");
		TYPE_ARTEMISGETAMPLIFIERSWITCHED pArtemisGetAmplifierSwitched = (TYPE_ARTEMISGETAMPLIFIERSWITCHED)pFuncs[26];
		if (NULL != pArtemisGetAmplifierSwitched)
			return (bool)(pArtemisGetAmplifierSwitched(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Set whether amp is switched off during exposures
typedef int(__stdcall * TYPE_ARTEMISSETAMPLIFIERSWITCHED)(ArtemisHandle hCam, bool bSwitched);
int artfn ArtemisSetAmplifierSwitched(ArtemisHandle hCam, bool bSwitched)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[51])
			pFuncs[51] = GetProcAddress(hArtemisDLL, "ArtemisSetAmplifierSwitched");
		TYPE_ARTEMISSETAMPLIFIERSWITCHED pArtemisSetAmplifierSwitched = (TYPE_ARTEMISSETAMPLIFIERSWITCHED)pFuncs[51];
		if (NULL != pArtemisSetAmplifierSwitched)
			return pArtemisSetAmplifierSwitched(hCam, bSwitched);
	}
	return (int)NULL;
}


// ------------------- Exposure Settings -----------------------------------

// Set the x,y binning factors
typedef int(__stdcall * TYPE_ARTEMISBIN)(ArtemisHandle hCam, int x, int y);
int artfn ArtemisBin(ArtemisHandle hCam, int x, int y)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[4])
			pFuncs[4] = GetProcAddress(hArtemisDLL, "ArtemisBin");
		TYPE_ARTEMISBIN pArtemisBin = (TYPE_ARTEMISBIN)pFuncs[4];
		if (NULL != pArtemisBin)
			return pArtemisBin(hCam, x, y);
	}
	return (int)NULL;
}

// Get the x,y binning factors
typedef int(__stdcall * TYPE_ARTEMISGETBIN)(ArtemisHandle hCam, int * x, int * y);
int artfn ArtemisGetBin(ArtemisHandle hCam, int * x, int * y)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[27])
			pFuncs[27] = GetProcAddress(hArtemisDLL, "ArtemisGetBin");
		TYPE_ARTEMISGETBIN pArtemisGetBin = (TYPE_ARTEMISGETBIN)pFuncs[27];
		if (NULL != pArtemisGetBin)
			return pArtemisGetBin(hCam, x, y);
	}
	return (int)NULL;
}

// Get the maximum x,y binning factors
typedef int(__stdcall * TYPE_ARTEMISGETMAXBIN)(ArtemisHandle hCam, int * x, int * y);
int artfn ArtemisGetMaxBin(ArtemisHandle hCam, int * x, int * y)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[32])
			pFuncs[32] = GetProcAddress(hArtemisDLL, "ArtemisGetMaxBin");
		TYPE_ARTEMISGETMAXBIN pArtemisGetMaxBin = (TYPE_ARTEMISGETMAXBIN)pFuncs[32];
		if (NULL != pArtemisGetMaxBin)
			return pArtemisGetMaxBin(hCam, x, y);
	}
	return (int)NULL;
}

// Get the pos and size of imaging subframe
typedef int(__stdcall * TYPE_ARTEMISGETSUBFRAME)(ArtemisHandle hCam, int * x, int * y, int * w, int * h);
int artfn ArtemisGetSubframe(ArtemisHandle hCam, int * x, int * y, int * w, int * h)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[34])
			pFuncs[34] = GetProcAddress(hArtemisDLL, "ArtemisGetSubframe");
		TYPE_ARTEMISGETSUBFRAME pArtemisGetSubframe = (TYPE_ARTEMISGETSUBFRAME)pFuncs[34];
		if (NULL != pArtemisGetSubframe)
			return pArtemisGetSubframe(hCam, x, y, w, h);
	}
	return (int)NULL;
}

// set the pos and size of imaging subframe inunbinned coords
typedef int(__stdcall * TYPE_ARTEMISSUBFRAME)(ArtemisHandle hCam, int x, int y, int w, int h);
int artfn ArtemisSubframe(ArtemisHandle hCam, int x, int y, int w, int h)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[61])
			pFuncs[61] = GetProcAddress(hArtemisDLL, "ArtemisSubframe");
		TYPE_ARTEMISSUBFRAME pArtemisSubframe = (TYPE_ARTEMISSUBFRAME)pFuncs[61];
		if (NULL != pArtemisSubframe)
			return pArtemisSubframe(hCam, x, y, w, h);
	}
	return (int)NULL;
}

// Set the start x,y coords for imaging subframe.
// X,Y in unbinned coordinates
typedef int(__stdcall * TYPE_ARTEMISSUBFRAMEPOS)(ArtemisHandle hCam, int x, int y);
int artfn ArtemisSubframePos(ArtemisHandle hCam, int x, int y)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[62])
			pFuncs[62] = GetProcAddress(hArtemisDLL, "ArtemisSubframePos");
		TYPE_ARTEMISSUBFRAMEPOS pArtemisSubframePos = (TYPE_ARTEMISSUBFRAMEPOS)pFuncs[62];
		if (NULL != pArtemisSubframePos)
			return pArtemisSubframePos(hCam, x, y);
	}
	return (int)NULL;
}

// Set the width and height of imaging subframe
// W,H in unbinned coordinates
typedef int(__stdcall * TYPE_ARTEMISSUBFRAMESIZE)(ArtemisHandle hCam, int w, int h);
int artfn ArtemisSubframeSize(ArtemisHandle hCam, int w, int h)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[63])
			pFuncs[63] = GetProcAddress(hArtemisDLL, "ArtemisSubframeSize");
		TYPE_ARTEMISSUBFRAMESIZE pArtemisSubframeSize = (TYPE_ARTEMISSUBFRAMESIZE)pFuncs[63];
		if (NULL != pArtemisSubframeSize)
			return pArtemisSubframeSize(hCam, w, h);
	}
	return (int)NULL;
}

// Set subsampling mode (if supported by camera). True=subsampling enabled.
typedef int(__stdcall * TYPE_ARTEMISSETSUBSAMPLE)(ArtemisHandle hCam, bool bSub);
int artfn ArtemisSetSubSample(ArtemisHandle hCam, bool bSub)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[80])
			pFuncs[80] = GetProcAddress(hArtemisDLL, "ArtemisSetSubSample");
		TYPE_ARTEMISSETSUBSAMPLE pArtemisSetSubSample = (TYPE_ARTEMISSETSUBSAMPLE)pFuncs[80];
		if (NULL != pArtemisSetSubSample)
			return pArtemisSetSubSample(hCam, bSub);
	}
	return (int)NULL;
}

// Return true if continuous exposing mode is supported, in which the exposure function simply reads out the CCD without clearing it first and without waiting
typedef bool(__stdcall * TYPE_ARTEMISCONTINUOUSEXPOSINGMODESUPPORTED)(ArtemisHandle hCam);
bool artfn ArtemisContinuousExposingModeSupported(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[71])
			pFuncs[71] = GetProcAddress(hArtemisDLL, "ArtemisContinuousExposingModeSupported");
		TYPE_ARTEMISCONTINUOUSEXPOSINGMODESUPPORTED pArtemisContinuousExposingModeSupported = (TYPE_ARTEMISCONTINUOUSEXPOSINGMODESUPPORTED)pFuncs[71];
		if (NULL != pArtemisContinuousExposingModeSupported)
			return (bool)(pArtemisContinuousExposingModeSupported(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Return true if overlapped mode is set - ie the exposure function simply reads out the CCD without clearing it first and without waiting
typedef bool(__stdcall * TYPE_ARTEMISGETCONTINUOUSEXPOSINGMODE)(ArtemisHandle hCam);
bool artfn ArtemisGetContinuousExposingMode(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[72])
			pFuncs[72] = GetProcAddress(hArtemisDLL, "ArtemisGetContinuousExposingMode");
		TYPE_ARTEMISGETCONTINUOUSEXPOSINGMODE pArtemisGetContinuousExposingMode = (TYPE_ARTEMISGETCONTINUOUSEXPOSINGMODE)pFuncs[72];
		if (NULL != pArtemisGetContinuousExposingMode)
			return (bool)(pArtemisGetContinuousExposingMode(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Enable/disable overlapped mode - ie the exposure function is to simply read out the CCD without clearing it first and without waiting
typedef int(__stdcall * TYPE_ARTEMISSETCONTINUOUSEXPOSINGMODE)(ArtemisHandle hCam, bool bEnable);
int artfn ArtemisSetContinuousExposingMode(ArtemisHandle hCam, bool bEnable)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[75])
			pFuncs[75] = GetProcAddress(hArtemisDLL, "ArtemisSetContinuousExposingMode");
		TYPE_ARTEMISSETCONTINUOUSEXPOSINGMODE pArtemisSetContinuousExposingMode = (TYPE_ARTEMISSETCONTINUOUSEXPOSINGMODE)pFuncs[75];
		if (NULL != pArtemisSetContinuousExposingMode)
			return pArtemisSetContinuousExposingMode(hCam, bEnable);
	}
	return (int)NULL;
}

// Return true if dark mode is set - ie the shutter is kept closed during exposures
typedef bool(__stdcall * TYPE_ARTEMISGETDARKMODE)(ArtemisHandle hCam);
bool artfn ArtemisGetDarkMode(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[28])
			pFuncs[28] = GetProcAddress(hArtemisDLL, "ArtemisGetDarkMode");
		TYPE_ARTEMISGETDARKMODE pArtemisGetDarkMode = (TYPE_ARTEMISGETDARKMODE)pFuncs[28];
		if (NULL != pArtemisGetDarkMode)
			return (bool)(pArtemisGetDarkMode(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Enable/disable dark mode - ie the shutter is to be kept closed during exposures
typedef int(__stdcall * TYPE_ARTEMISSETDARKMODE)(ArtemisHandle hCam, bool bEnable);
int artfn ArtemisSetDarkMode(ArtemisHandle hCam, bool bEnable)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[53])
			pFuncs[53] = GetProcAddress(hArtemisDLL, "ArtemisSetDarkMode");
		TYPE_ARTEMISSETDARKMODE pArtemisSetDarkMode = (TYPE_ARTEMISSETDARKMODE)pFuncs[53];
		if (NULL != pArtemisSetDarkMode)
			return pArtemisSetDarkMode(hCam, bEnable);
	}
	return (int)NULL;
}

// Allow/disallow automatic black level adjustment (only applies to quickercams)
typedef int(__stdcall * TYPE_ARTEMISAUTOADJUSTBLACKLEVEL)(ArtemisHandle hCam, bool bEnable);
int artfn ArtemisAutoAdjustBlackLevel(ArtemisHandle hCam, bool bEnable)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[3])
			pFuncs[3] = GetProcAddress(hArtemisDLL, "ArtemisAutoAdjustBlackLevel");
		TYPE_ARTEMISAUTOADJUSTBLACKLEVEL pArtemisAutoAdjustBlackLevel = (TYPE_ARTEMISAUTOADJUSTBLACKLEVEL)pFuncs[3];
		if (NULL != pArtemisAutoAdjustBlackLevel)
			return pArtemisAutoAdjustBlackLevel(hCam, bEnable);
	}
	return (int)NULL;
}

// Set preview mode (if supported by camera). True=preview mode enabled.
typedef int(__stdcall * TYPE_ARTEMISSETPREVIEW)(ArtemisHandle hCam, bool bPrev);
int artfn ArtemisSetPreview(ArtemisHandle hCam, bool bPrev)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[54])
			pFuncs[54] = GetProcAddress(hArtemisDLL, "ArtemisSetPreview");
		TYPE_ARTEMISSETPREVIEW pArtemisSetPreview = (TYPE_ARTEMISSETPREVIEW)pFuncs[54];
		if (NULL != pArtemisSetPreview)
			return pArtemisSetPreview(hCam, bPrev);
	}
	return (int)NULL;
}

// Set the Precharge mode
typedef int(__stdcall * TYPE_ARTEMISPRECHARGEMODE)(ArtemisHandle hCam, int mode);
int artfn ArtemisPrechargeMode(ArtemisHandle hCam, int mode)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[47])
			pFuncs[47] = GetProcAddress(hArtemisDLL, "ArtemisPrechargeMode");
		TYPE_ARTEMISPRECHARGEMODE pArtemisPrechargeMode = (TYPE_ARTEMISPRECHARGEMODE)pFuncs[47];
		if (NULL != pArtemisPrechargeMode)
			return pArtemisPrechargeMode(hCam, mode);
	}
	return (int)NULL;
}

// Set the 8-bit imaging mode
typedef int(__stdcall * TYPE_ARTEMISEIGHTBITMODE)(ArtemisHandle hCam, bool eightbits);
int artfn ArtemisEightBitMode(ArtemisHandle hCam, bool eightbits)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[48])
			pFuncs[48] = GetProcAddress(hArtemisDLL, "ArtemisEightBitMode");
		TYPE_ARTEMISEIGHTBITMODE pArtemisEightBitMode = (TYPE_ARTEMISEIGHTBITMODE)pFuncs[48];
		if (NULL != pArtemisEightBitMode)
			return pArtemisEightBitMode(hCam, eightbits);
	}
	return (int)NULL;
}

// Return true if camera can overlap exposure time with image download time
typedef bool(__stdcall * TYPE_ARTEMISCANOVERLAPEXPOSURES)(ArtemisHandle hCam);
bool artfn ArtemisCanOverlapExposures(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[70])
			pFuncs[70] = GetProcAddress(hArtemisDLL, "ArtemisCanOverlapExposures");
		TYPE_ARTEMISCANOVERLAPEXPOSURES pArtemisCanOverlapExposures = (TYPE_ARTEMISCANOVERLAPEXPOSURES)pFuncs[70];
		if (NULL != pArtemisCanOverlapExposures)
			return (bool)(pArtemisCanOverlapExposures(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}

// Request an overlapped exposure to be downloaded when ready
typedef int(__stdcall * TYPE_ARTEMISSTARTOVERLAPPEDEXPOSURE)(ArtemisHandle hCam);
int artfn ArtemisStartOverlappedExposure(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[81])
			pFuncs[81] = GetProcAddress(hArtemisDLL, "ArtemisStartOverlappedExposure");
		TYPE_ARTEMISSTARTOVERLAPPEDEXPOSURE pArtemisStartOverlappedExposure = (TYPE_ARTEMISSTARTOVERLAPPEDEXPOSURE)pFuncs[81];
		if (NULL != pArtemisStartOverlappedExposure)
			return pArtemisStartOverlappedExposure(hCam);
	}
	return (int)NULL;
}

// Set duration for overlapped exposures. Call once, not every frame.
typedef int(__stdcall * TYPE_ARTEMISSETOVERLAPPEDEXPOSURETIME)(ArtemisHandle hCam, float Seconds);
int artfn ArtemisSetOverlappedExposureTime(ArtemisHandle hCam, float Seconds)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[78])
			pFuncs[78] = GetProcAddress(hArtemisDLL, "ArtemisSetOverlappedExposureTime");
		TYPE_ARTEMISSETOVERLAPPEDEXPOSURETIME pArtemisSetOverlappedExposureTime = (TYPE_ARTEMISSETOVERLAPPEDEXPOSURETIME)pFuncs[78];
		if (NULL != pArtemisSetOverlappedExposureTime)
			return pArtemisSetOverlappedExposureTime(hCam, Seconds);
	}
	return (int)NULL;
}

// Set External Trigger mode (if supported by camera). True=wait for trigger.
typedef int(__stdcall * TYPE_ARTEMISTRIGGEREDEXPOSURE)(ArtemisHandle hCam, bool bAwaitTrigger);
int artfn ArtemisTriggeredExposure(ArtemisHandle hCam, bool bAwaitTrigger)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[82])
			pFuncs[82] = GetProcAddress(hArtemisDLL, "ArtemisTriggeredExposure");
		TYPE_ARTEMISTRIGGEREDEXPOSURE pArtemisTriggeredExposure = (TYPE_ARTEMISTRIGGEREDEXPOSURE)pFuncs[82];
		if (NULL != pArtemisTriggeredExposure)
			return pArtemisTriggeredExposure(hCam, bAwaitTrigger);
	}
	return (int)NULL;
}

// Get current image processing options
typedef int(__stdcall * TYPE_ARTEMISGETPROCESSING)(ArtemisHandle hCam);
int artfn ArtemisGetProcessing(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[33])
			pFuncs[33] = GetProcAddress(hArtemisDLL, "ArtemisGetProcessing");
		TYPE_ARTEMISGETPROCESSING pArtemisGetProcessing = (TYPE_ARTEMISGETPROCESSING)pFuncs[33];
		if (NULL != pArtemisGetProcessing)
			return pArtemisGetProcessing(hCam);
	}
	return (int)NULL;
}

// Set current image processing options
typedef int(__stdcall * TYPE_ARTEMISSETPROCESSING)(ArtemisHandle hCam, int options);
int artfn ArtemisSetProcessing(ArtemisHandle hCam, int options)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[55])
			pFuncs[55] = GetProcAddress(hArtemisDLL, "ArtemisSetProcessing");
		TYPE_ARTEMISSETPROCESSING pArtemisSetProcessing = (TYPE_ARTEMISSETPROCESSING)pFuncs[55];
		if (NULL != pArtemisSetProcessing)
			return pArtemisSetProcessing(hCam, options);
	}
	return (int)NULL;
}

// Return true if the previous overlapped exposure had the requested exposure time.
typedef bool(__stdcall * TYPE_ARTEMISOVERLAPPEDEXPOSUREVALID)(ArtemisHandle hCam);
bool artfn ArtemisOverlappedExposureValid(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[74])
			pFuncs[74] = GetProcAddress(hArtemisDLL, "ArtemisOverlappedExposureValid");
		TYPE_ARTEMISOVERLAPPEDEXPOSUREVALID pArtemisOverlappedExposureValid = (TYPE_ARTEMISOVERLAPPEDEXPOSUREVALID)pFuncs[74];
		if (NULL != pArtemisOverlappedExposureValid)
			return (bool)(pArtemisOverlappedExposureValid(hCam) ? 1 : 0);
	}
	return (bool)NULL;
}


// Set conversion speed.
typedef int(__stdcall * TYPE_ARTEMISSETOVERSAMPLE)(ArtemisHandle hCam, int oversample);
int artfn ArtemisSetOversample(ArtemisHandle hCam, int oversample)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[79])
			pFuncs[79] = GetProcAddress(hArtemisDLL, "ArtemisSetOversample");
		TYPE_ARTEMISSETOVERSAMPLE pArtemisSetOversample = (TYPE_ARTEMISSETOVERSAMPLE)pFuncs[79];
		if (NULL != pArtemisSetOversample)
			return pArtemisSetOversample(hCam, oversample);
	}
	return (int)NULL;
}






// ------------------- Camera Control -----------------------------------


// Clear the VRegs
typedef int(__stdcall * TYPE_ARTEMISCLEARVREGS)(ArtemisHandle hCam);
int artfn ArtemisClearVRegs(ArtemisHandle hCam)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[7])
			pFuncs[7] = GetProcAddress(hArtemisDLL, "ArtemisClearVRegs");
		TYPE_ARTEMISCLEARVREGS pArtemisClearVRegs = (TYPE_ARTEMISCLEARVREGS)pFuncs[7];
		if (NULL != pArtemisClearVRegs)
			return pArtemisClearVRegs(hCam);
	}
	return (int)NULL;
}



// ------------------- Other -----------------------------------

// Sets the error director
typedef int(__stdcall * TYPE_ARTEMISSETERRORDIR)(const char * errorDir);
int artfn ArtemisSetErrorDir(const char * errorDir)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[67])
			pFuncs[67] = GetProcAddress(hArtemisDLL, "ArtemisSetErrorDir");
		TYPE_ARTEMISSETERRORDIR pArtemisSetErrorDir = (TYPE_ARTEMISSETERRORDIR)pFuncs[67];
		if (NULL != pArtemisSetErrorDir)
			return pArtemisSetErrorDir(errorDir);
	}
	return (int)NULL;
}

// Sets whether or not the message boxes will appear
typedef int(__stdcall * TYPE_ARTEMISSETALLOWMESSAGEBOXES)(bool allow);
int artfn ArtemisSetAllowMessageBoxes(bool allow)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[68])
			pFuncs[68] = GetProcAddress(hArtemisDLL, "ArtemisSetAllowMessageBoxes");
		TYPE_ARTEMISSETALLOWMESSAGEBOXES pArtemisSetAllowMessageBoxes = (TYPE_ARTEMISSETALLOWMESSAGEBOXES)pFuncs[68];
		if (NULL != pArtemisSetAllowMessageBoxes)
			return pArtemisSetAllowMessageBoxes(allow);
	}
	return (int)NULL;
}

// Sets whether or not 'StopExposure' kills all downloads (Used mainly for Infinity)
typedef int(__stdcall * TYPE_ARTEMISSTOPKILLSALLDOWNLOADS)(bool value);
int artfn ArtemisStopKillsAllDownloads(bool value)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[69])
			pFuncs[69] = GetProcAddress(hArtemisDLL, "ArtemisStopKillsAllDownloads");
		TYPE_ARTEMISSTOPKILLSALLDOWNLOADS pArtemisStopKillsAllDownloads = (TYPE_ARTEMISSTOPKILLSALLDOWNLOADS)pFuncs[69];
		if (NULL != pArtemisStopKillsAllDownloads)
			return pArtemisStopKillsAllDownloads(value);
	}
	return (int)NULL;
}

typedef int(__stdcall * TYPE_ARTEMISREFRESHDEVICES)(int Device);
int artfn ArtemisRefreshDevices(int Device)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[17])
			pFuncs[17] = GetProcAddress(hArtemisDLL, "ArtemisRefreshDevices");
		TYPE_ARTEMISREFRESHDEVICES pArtemisRefreshDevices = (TYPE_ARTEMISREFRESHDEVICES)pFuncs[17];
		if (NULL != pArtemisRefreshDevices)
			return pArtemisRefreshDevices(Device);
	}
	return (int)NULL;
}




// ---------------- Hopefully Unused!! --------------------------

// Set download thread to high or normal priority
typedef int(__stdcall * TYPE_ARTEMISHIGHPRIORITY)(ArtemisHandle hCam, bool bHigh);
int artfn ArtemisHighPriority(ArtemisHandle hCam, bool bHigh)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[37])
			pFuncs[37] = GetProcAddress(hArtemisDLL, "ArtemisHighPriority");
		TYPE_ARTEMISHIGHPRIORITY pArtemisHighPriority = (TYPE_ARTEMISHIGHPRIORITY)pFuncs[37];
		if (NULL != pArtemisHighPriority)
			return pArtemisHighPriority(hCam, bHigh);
	}
	return (int)NULL;
}

// Get an internal DLL value specified by peekCode
typedef int(__stdcall * TYPE_ARTEMISPEEK)(ArtemisHandle hCam, int peekCode, int* peekValue);
int artfn ArtemisPeek(ArtemisHandle hCam, int peekCode, int* peekValue)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[45])
			pFuncs[45] = GetProcAddress(hArtemisDLL, "ArtemisPeek");
		TYPE_ARTEMISPEEK pArtemisPeek = (TYPE_ARTEMISPEEK)pFuncs[45];
		if (NULL != pArtemisPeek)
			return pArtemisPeek(hCam, peekCode, peekValue);
	}
	return (int)NULL;
}

// Set an internal DLL value specified by pokeCode
typedef int(__stdcall * TYPE_ARTEMISPOKE)(ArtemisHandle hCam, int pokeCode, int pokeValue);
int artfn ArtemisPoke(ArtemisHandle hCam, int pokeCode, int pokeValue)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[46])
			pFuncs[46] = GetProcAddress(hArtemisDLL, "ArtemisPoke");
		TYPE_ARTEMISPOKE pArtemisPoke = (TYPE_ARTEMISPOKE)pFuncs[46];
		if (NULL != pArtemisPoke)
			return pArtemisPoke(hCam, pokeCode, pokeValue);
	}
	return (int)NULL;
}

/////////////////////////////////////////////////
// Get camera description, for 3rd-party software
// recv is a 40-byte buffer for the data
// info tells which data to return:
//  0  camera description from firmware
//  1  FTDI device name
//  2  FTDI device serial number
// unit is the camera number
// returns:
//  0  OK
//  1  camera busy
//  2  no camera active
typedef int(__stdcall * TYPE_ARTEMISGETDESCRIPTION)(char * recv, int info, int unit);
int artfn ArtemisGetDescription(char * recv, int info, int unit)
{
	if (hArtemisDLL)
	{
		if (NULL == pFuncs[29])
			pFuncs[29] = GetProcAddress(hArtemisDLL, "ArtemisGetDescription");
		TYPE_ARTEMISGETDESCRIPTION pArtemisGetDescription = (TYPE_ARTEMISGETDESCRIPTION)pFuncs[29];
		if (NULL != pArtemisGetDescription)
			return pArtemisGetDescription(recv, info, unit);
	}
	return (int)NULL;
}














// Try to load the Artemis DLL.
// Returns true if loaded ok.
bool artfn ArtemisLoadDLL(char *fileName)
{
	std::string fileStr = fileName;

#if _WIN32
	hArtemisDLL = LoadLibraryA(fileStr.c_str());
#else
	hArtemisDLL = dlopen(fileStr.c_str(), RTLD_NOW);
#endif

	if (hArtemisDLL == NULL)
		return false;
	for (int i = 0; i<NFUNCS; i++)
		pFuncs[i] = NULL;
	return true;
}

// Unload the Artemis DLL.
void artfn ArtemisUnLoadDLL()
{
	if (hArtemisDLL != NULL)
	{
#if _WIN32
		FreeLibrary(hArtemisDLL);
#else
		dlclose(hArtemisDLL);
#endif
	}

	hArtemisDLL = NULL;
}












